#ifndef __DEBUG_H__
#define __DEBUG_H__

#include <stdio.h>

typedef enum
{
  DB_ABORT,
  DB_ERROR,
  DB_WARNING,
  DB_INFO,
  DB_TRACE
} debug_level;

void debug(debug_level level, const char *format, ...);

#ifdef DEBUG
static char *debug_levels[] = {
  "ABT",
  "ERR",
  "WRN",
  "INF",
  "TRC"
};

#define debug(level, format, args...)\
  if((1 << level) & DEBUG){\
    fprintf(stderr, "MYRINET<%s> ", debug_levels[level]);\
    fprintf(stderr, format, ## args);\
  }\

#else

#define debug(level, format, args...)

#endif /* DEBUG */

#endif /* __DEBUG_H__ */

