#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/ioctl.h> 

#include <debug.h>
#include <pcimap.h>

#define PCIMAP_GET_SIZE _IOC(_IOC_WRITE, 0, 1, 4)
#define PCIMAP_GET_PHY_ADDR _IOC(_IOC_WRITE, 0, 2, 4)

PCI_Mapped_Device::PCI_Mapped_Device(int unit)
{
  int fd, err;
  char dev_name[]="/dev/mlanaiX";

  log_addr = 0;

  dev_name[11] = '0' + unit;
  fd = open(dev_name, O_RDWR);
  if(fd < 0) {
    debug(DB_ERROR, "can't open %s!\n", dev_name);
    return;
  }

  err = ioctl(fd, PCIMAP_GET_SIZE, &size);
  if(err < 0) {
    debug(DB_ERROR, "can't get %s's size!\n", dev_name);
    return;
  }

  err = ioctl(fd, PCIMAP_GET_PHY_ADDR, &phy_addr);
  if(err < 0) {
    debug(DB_ERROR, "can't get %s's physical address!\n", dev_name);
    return;
  }

  log_addr = mmap(0, size, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0);
  if((int)log_addr < 0) {
    debug(DB_ERROR, "can't map %s!\n", dev_name);
    return;
  }
}
