#include <stdio.h>
#include <myrinet.h>

#define MESSAGE_LENGTH 64 

int main(int argc, char *argv[])
{
  if(argc != 1) {
    fprintf(stderr, "Usage: %s\n", argv[0]);
    return -1;
  }

  printf("Myrinet Receiver\n");

  Myrinet *myrinet = new Myrinet;
  if(!myrinet) {
    fprintf(stderr, "Error: can't access Myrinet!\n");
    return -1;
  }
  
  char buf[MESSAGE_LENGTH];
  unsigned int len;
  for(unsigned int j = 0; j < 10; j++) {
    len = sizeof(buf);
    if(myrinet->receive(buf, &len) < 0) {
      fprintf(stderr, "Error: Myrinet receive failed!\n");
      return -1;
    }
    fprintf(stderr, "Myrinet message received: %s!\n", buf);
    
/*    for(unsigned int i = 0; i < sizeof(buf); i++)
      if(buf[i] != (char)i)
	fprintf(stderr,
		"Warning: %dth byte of message is %x and should be %x\n",
		i, buf[i], i);*/
  }

  len = sizeof(buf);
  if(myrinet->receive(buf, &len) < 0) {
    fprintf(stderr, "Error: Myrinet receive failed!\n");
    return -1;
  }
  fprintf(stderr, "Myrinet message received: %s!\n", buf);

  return 0;
}
