#include <unistd.h> 
#include <stdlib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <sys/ioctl.h> 

#include "pcimap.h"

int main(int argc, char *argv[])
{
    int i, fd0, err;
    char * ptr;
    unsigned long phy_addr, size;
    
    if(argc != 4) {
	fprintf(stderr, "Usage: %s device offset size!\n", argv[0]);
	return -1;
    }

    fd0 = open(argv[1], O_RDWR);
    if(fd0 < 0) {
	perror("open");
	return -1;
    }

    err = ioctl(fd0, PCIMAP_GET_SIZE, &size);
    if(err < 0) {
	perror("ioctl");
	return -1;
    }
    printf("PCI device memory size: %ld\n", size);

    err = ioctl(fd0, PCIMAP_GET_PHY_ADDR, &phy_addr);
    if(err < 0) {
	perror("ioctl");
	return -1;
    }
    printf("PCI device memory physical address: %lx\n", phy_addr);
    
    ptr = (char *)mmap(0, atoi(argv[3]), PROT_READ | PROT_WRITE, MAP_SHARED,
			  fd0, atoi(argv[2]));
    if((int)ptr < 0) {
	perror("mmap");
	return -1;
    } else {
	printf("PCI device memory logical address: %p\n", ptr);
	strcpy(ptr, "PCIMAP test OK!");
	printf("PCI device memory contents: ");
	for(i = 0; i < atoi(argv[3]); i++)
	    putchar(ptr[i]);
	putchar('\n');
    }

    close(fd0);

    return 0;
}
